
# FIXME: Use udev sooner or later...

%define atilibdir 	%{_libdir}/ati-fglrx
%define atilibdir32bit 	%{_prefix}/lib/ati-fglrx

%define majorver 9
%define minorver 7
%define inmajorver 8
%define inminorver 632

Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Summary: 	AMD/ATI proprietary driver for AMD/ATI Radeon graphic cards
Name: 		xorg-x11-drv-fglrx
Version: 	%{majorver}.%{minorver}
Release: 	1
Epoch:		1
Group: 		System/Configuration/Hardware
License: 	Distributable
URL:            http://www.ati.com/support/drivers/linux/radeon-linux.html

Source0:        https://a248.e.akamai.net/f/674/9206/0/www2.ati.com/drivers/linux/ati-driver-installer-%{majorver}-%{minorver}-x86.x86_64.run

#Source1:	atidri.sh

Source4:        ati-fglrx-fireglcontrol.desktop
Source12:       ati-fglrx.profile.d
Source14:       ati-fglrx-ati-powermode.sh
Source15:       ati-fglrx-a-ac-aticonfig
Source16:       ati-fglrx-a-lid-aticonfig

Source20:	51-fglrx.nodes
Source21:       40-fglrx-dri.rules

BuildRequires:  qt-devel, desktop-file-utils
BuildRequires:  mesa-libGLU-devel, mesa-libGL-devel, libXmu-devel, libXxf86vm-devel

Provides:   	fglrx-kmod-common = %{epoch}:%{version}
Provides:	xorg-x11-drv-fglrx = %{version}-%{release}

Conflicts:  	ati-fglrx
# the nvidia version of libGL might get drawn in, so
# we better make sure it isn't there during linking
BuildConflicts: xorg-x11-drv-nvidia
BuildConflicts: xorg-x11-drv-nvidia-legacy
BuildConflicts: xorg-x11-drv-nvidia-legacy96xx
Obsoletes:  	ati-fglrx

Requires(post):  kmod-fglrx >= %{version}
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch:  i686

# Require for rpm lzma compression transition
Requires:        rpm >= 4.4.2.3-1

%description
This package contains the X11 driver, utilities and libraries needed for the
ATI proprietary driver for ATI Radeon graphic cards.

%package devel
Summary:    ATI proprietary driver for ATI Radeon graphic cards, devel part
Group:      Development/Libraries
Requires:   %{name} = %{version}-%{release}

%description devel
This package provides header files and examples required for development
for the AMD/ATI proprietary driver for AMD/ATI Radeon graphic cards.

%preun
# only run if we deinstall the package, not during upgrade
#if [ $1 -eq 0 ]; then 
#fi

%postun 
/sbin/ldconfig

%post 
/sbin/ldconfig

%prep
%setup -q -c -T
sh %{SOURCE0} --extract fglrx
tar -cjf fglrx-kmod-data-%{version}.tar.bz2 fglrx/ATI_LICENSE.TXT fglrx/common/*/modules/fglrx/ fglrx/arch/*/*/modules/fglrx/
mkdir fglrxpkg

%ifarch %{ix86}
cp -r fglrx/common/* fglrx/x740/* fglrx/arch/x86/* fglrxpkg/
%endif

%ifarch x86_64
cp -r fglrx/common/* fglrx/x740_64a/* fglrx/arch/x86_64/* fglrxpkg/
%endif



%build
[ -n "$QTDIR" ] || . %{_sysconfdir}/profile.d/qt.sh


%install
rm -rf $RPM_BUILD_ROOT ./__doc

set +x
for file in $(cd fglrxpkg &> /dev/null; find . -type f | grep -v -e 'fireglcontrol.kdelnk$' -e 'fireglcontrol.desktop$' -e 'lib/modules/fglrx$' -e 'ati.xpm$' -e 'fireglcontrolpanel$' -e '/usr/share/doc/fglrx/' -e 'fglrx_panel_sources.tgz$' -e 'fireglcontrol_kde3.desktop$' -e 'fglrx_sample_source.tgz$' -e 'fglrx_sample_source.tgz$' -e '^./lib/modules/fglrx' -e 'amdcccle_kde3.desktop' -e 'amdcccle.kdelnk' -e 'amdcccle.desktop$' -e 'ccc_small.xpm$' -e 'ccc_large.xpm$' -e 'amdcccle_ar_EG.qm$' -e 'amdcccle_cs.qm$' -e 'amdcccle_da_DK.qm$' -e 'amdcccle_de.qm$' -e 'amdcccle_el_GR.qm$' -e 'amdcccle_es_ES.qm$' -e 'amdcccle_fi_FI.qm$' -e 'amdcccle_fr_FR.qm$' -e 'amdcccle_he.qm$' -e 'amdcccle_hu_HU.qm$' -e 'amdcccle_it_IT.qm$' -e 'amdcccle_ja.qm$' -e 'amdcccle_ko_KR.qm$' -e 'amdcccle_nl_NL.qm$' -e 'amdcccle_no.qm$' -e 'amdcccle_pl.qm$' -e 'amdcccle_pt_BR.qm$' -e 'amdcccle_ru_RU.qm$' -e 'amdcccle_sv_SE.qm$' -e 'amdcccle_th.qm$' -e 'amdcccle_tr_TR.qm$' -e 'amdcccle_zh_CN.qm$' -e 'amdcccle_zh_TW.qm$' )

do
  if [[ ! "/${file##}" = "/${file}" ]]
  then
    install -D -p -m 0644 fglrxpkg/${file} ./__doc/${file##./usr/share/doc/fglrx/}
  elif [[ ! "/${file##./usr/X11R6/lib/modules/extensions}" = "/${file}" ]]
  then
    install -D -p -m 0755 fglrxpkg/${file} $RPM_BUILD_ROOT/%{_libdir}/xorg/modules/extensions/fglrx/${file##./usr/X11R6/lib/modules/extensions}
  elif [[ ! "/${file##./usr/X11R6/%{_lib}/modules}" = "/${file}" ]]
  then
    install -D -p -m 0755 fglrxpkg/${file} $RPM_BUILD_ROOT/%{_libdir}/xorg/modules/${file##./usr/X11R6/%{_lib}/modules}
  elif [[ ! "/${file##./usr/X11R6/lib/modules}" = "/${file}" ]]
  then
    install -D -p -m 0755 fglrxpkg/${file} $RPM_BUILD_ROOT/%{_prefix}/lib/xorg/modules/${file##./usr/X11R6/lib/modules}
  elif [[ ! "/${file##./usr/X11R6/include/X11/extensions}" = "/${file}" ]]
  then
    install -D -p -m 0644 fglrxpkg/${file} $RPM_BUILD_ROOT/%{_includedir}/X11/extensions/${file##./usr/X11R6/include/X11/extensions}
  elif [[ ! "/${file##./usr/X11R6/%{_lib}/}" = "/${file}" ]]
  then
    install -D -p -m 0755 fglrxpkg/${file} $RPM_BUILD_ROOT/%{atilibdir}/${file##./usr/X11R6/%{_lib}/}
  elif [[ ! "/${file##./usr/X11R6/lib/}" = "/${file}" ]]
  then
    install -D -p -m 0755 fglrxpkg/${file} $RPM_BUILD_ROOT/%{atilibdir32bit}/${file##./usr/X11R6/lib/}
  elif [[ ! "/${file##./usr/X11R6/bin/}" = "/${file}" ]]
  then
    install -D -p -m 0755 fglrxpkg/${file} $RPM_BUILD_ROOT/%{_bindir}/${file##./usr/X11R6/bin/}
  elif [[ ! "/${file##./usr/bin/}" = "/${file}" ]]
  then
    install -D -p -m 0755 fglrxpkg/${file} $RPM_BUILD_ROOT/%{_sbindir}/${file##./usr/bin/}
  elif [[ ! "/${file##./usr/sbin/}" = "/${file}" ]]
  then
    install -D -p -m 0755 fglrxpkg/${file} $RPM_BUILD_ROOT/%{_sbindir}/${file##./usr/sbin/}
  elif [[ ! "/${file##./etc/ati/}" = "/${file}" ]]
  then
    install -D -p -m 0755 fglrxpkg/${file} $RPM_BUILD_ROOT/%{_sysconfdir}/ati/${file##./etc/ati/}
  elif [[ ! "/${file##./usr/include/}" = "/${file}" ]] || [[ ! "/${file##./etc/}" = "/${file}" ]] || [[ ! "/${file##./usr/share/man/}" = "/${file}" ]] || [[  "/${file##./usr/share/ati/amdcccle/}" = "/${file}" ]]
  then
    install -D -p -m 0644 fglrxpkg/${file} $RPM_BUILD_ROOT/${file}
  else
    echo ${file} found -- don\'t know how to handle
    exit 1
  fi
done
set -x

pwd
install -d -D -p -m 0755 fglrxpkg/usr/share/ati/ $RPM_BUILD_ROOT/${_datadir}/ati

# Change perms on static libs. Can't fathom how to do it nicely above.
find $RPM_BUILD_ROOT/%{atilibdir} -type f -name "*.a" -exec chmod 0644 '{}' \;

ln -s libGL.so.1.2 $RPM_BUILD_ROOT/%{atilibdir}/libGL.so.1
ln -s libfglrx_gamma.so.1.0 $RPM_BUILD_ROOT/%{atilibdir}/libfglrx_gamma.so.1
ln -s libfglrx_dm.so.1.0 $RPM_BUILD_ROOT/%{atilibdir}/libfglrx_dm.so.1
ln -s libfglrx_pp.so.1.0 $RPM_BUILD_ROOT/%{atilibdir}/libfglrx_pp.so.1
ln -s libfglrx_tvout.so.1.0 $RPM_BUILD_ROOT/%{atilibdir}/libfglrx_tvout.so.1

# workaround for modular X, part1
mkdir -p $RPM_BUILD_ROOT/usr/lib/dri/
mkdir -p $RPM_BUILD_ROOT/usr/X11R6/lib/modules/dri/
ln -s %{_libdir}/xorg/modules/dri/fglrx_dri.so $RPM_BUILD_ROOT/usr/lib/dri/fglrx_dri.so
ln -s %{_libdir}/xorg/modules/dri/fglrx_dri.so $RPM_BUILD_ROOT/usr/X11R6/lib/modules/dri/fglrx_dri.so
#ln -s %{_libdir}/xorg/modules/dri/atiogl_a_dri.so $RPM_BUILD_ROOT/usr/lib/dri/atiogl_a_dri.so
%ifarch x86_64
mkdir -p $RPM_BUILD_ROOT/usr/X11R6/lib/modules/dri/
ln -s %{_prefix}/lib/xorg/modules/dri/fglrx_dri.so $RPM_BUILD_ROOT/usr/X11R6/lib/modules/dri/fglrx_dri.so
#ln -s %{_prefix}/lib/xorg/modules/dri/atiogl_a_dri.so $RPM_BUILD_ROOT/usr/X11R6/lib/modules/dri/atiogl_a_dri.so
%endif

install -D -p -m 0755 %{SOURCE12} $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/ati-fglrx.sh

#install -D -p -m 0755 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/init.d/atidri

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/
echo "disabled" > $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/ati-fglrx-config-display

mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
install -D -p -m 0644 %{SOURCE4} $RPM_BUILD_ROOT%{_datadir}/applications
#desktop-file-install --vendor CCux \
#    --dir $RPM_BUILD_ROOT%{_datadir}/applications \
#    --add-category System \
#    --add-category Application \
#    --add-category Qt \
#    %{SOURCE4}

# Set the correct path for gdm's Xauth file
sed -i 's|GDM_AUTH_FILE=/var/lib/gdm/$1.Xauth|GDM_AUTH_FILE=/var/gdm/$1.Xauth|' fglrxpkg/etc/ati/authatieventsd.sh

# Fix odd perms
find fglrxpkg -type f -perm 0555 -exec chmod 0755 '{}' \;

mkdir -p $RPM_BUILD_ROOT%_sysconfdir/ld.so.conf.d
echo %{atilibdir} > $RPM_BUILD_ROOT%_sysconfdir/ld.so.conf.d/fglrx.conf

# DRI device nodes and permissions
install -D -p -m 0644 %{SOURCE20} $RPM_BUILD_ROOT%{_sysconfdir}/udev/makedev.d/51-fglrx.nodes
install -D -p -m 0644 %{SOURCE21} $RPM_BUILD_ROOT%{_sysconfdir}/udev/rules.d/40-fglrx-dri.rules

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc fglrxpkg/usr/share/doc/fglrx/*
%doc /usr/share/doc/amdcccle/ccc_copyrights.txt
%dir %{atilibdir}
%{_prefix}/X11R6/
%{_sysconfdir}/profile.d/ati-fglrx.sh
%config %{_sysconfdir}/ati/authatieventsd.sh
%config %{_sysconfdir}/ati/logo.xbm.example
%config %{_sysconfdir}/ati/logo_mask.xbm.example
%config %{_sysconfdir}/ati/amdpcsdb.default
%config %{_sysconfdir}/ati/atiogl.xml
%config %{_sysconfdir}/ati/signature
%config %{_sysconfdir}/ati/control
%{_sbindir}/*
%{_bindir}/*
%{atilibdir}/*.so.*
%{atilibdir}/libatiadlxx.so
%{atilibdir}/libAMDXvBA.cap
%{_libdir}/libaticalcl.so
%{_libdir}/libaticaldd.so
%{_libdir}/libaticalrt.so
%{_libdir}/xorg/modules/drivers/fglrx_drv.so
%{_libdir}/xorg/modules/linux/libfglrxdrm.so
%{_libdir}/xorg/modules/amdxmm.so
%{_libdir}/xorg/modules/dri/*_dri.so
%{_libdir}/xorg/modules/extensions/fglrx/libdri.so
%{_libdir}/xorg/modules/extensions/fglrx/libglx.so
%{_libdir}/dri/*_dri.so
%{_libdir}/xorg/modules/esut.a
%{_libdir}/xorg/modules/glesx.so
%{_datadir}/applications/ati-fglrx-fireglcontrol.desktop
%{_mandir}/man[1-9]/atieventsd.*
/etc/ld.so.conf.d/fglrx.conf
/etc/sysconfig/ati-fglrx-config-display
%{_sysconfdir}/udev/makedev.d/51-fglrx.nodes
%{_sysconfdir}/udev/rules.d/40-fglrx-dri.rules

/opt/kde3/share/applnk/amdccclesu_kde3.desktop
/usr/share/applnk/amdccclesu.kdelnk
/usr/share/gnome/apps/amdccclesu.desktop


%files devel
%defattr(-,root,root,-)
#%doc fglrxpkg/usr/src/ati/fglrx_sample_source.tgz
%{atilibdir}/*.a
%{_includedir}/GL/glxATI.h
%{_includedir}/GL/glATI.h
%{_includedir}/X11/extensions/fglrx_gamma.h
%{_includedir}/ATI/

%changelog
* Mon Jul 27 2009 Karsten Brockmann <arcam@ccux-linux.de> 1:9.7-1
- Version update, driver version 8.632
* Fri Jan 30 2009 Karsten Brockmann <arcam@ccux-linux.de> 1:9.1-1
- Version update, driver version 8.573
* Thu Dec 11 2008 Karsten Brockmann <arcam@ccux-linux.de> 1:8.12-1
- Version update, driver version 8.561
* Sun Nov 16 2008 Karsten Brockmann <arcam@ccux-linux.de> 1:8.11-2
- took the right path (740) this time
* Sat Nov 15 2008 Karsten Brockmann <arcam@ccux-linux.de> 1:8.11-1
- Version update, driver version 8.552
* Thu Sep 18 2008 Karsten Brockmann <arcam@ccux-linux.de> 1:8.9-1
- Version update, driver version 8.532
* Thu Aug 21 2008 Karsten Brockmann <arcam@ccux-linux.de> 1:8.8-1
- Version update, driver version 8.522
* Fri Aug 08 2008 Karsten Brockmann <arcam@ccux-linux.de> 1:8.7-3
- fixed device nodes permissions
* Wed Aug 06 2008 Karsten Brockmann <arcam@ccux-linux.de> 1:8.7-2
- creation of devicefiles is now done by udev, deleted initscript
* Thu Jul 24 2008 Karsten Brockmann <arcam@ccux-linux.de> 1:8.7-1
- Version update, driver version 8.512
* Mon Jul 14 2008 Karsten Brockmann <arcam@ccux-linux.de> 1:8.6-2
- resolved circular dependency towards kmod package
* Sat Jun 21 2008 Karsten Brockmann <arcam@ccux-linux.de> 1:8.6-1
- Version update, driver version 8.501
* Sun May 25 2008 Karsten Brockmann <arcam@ccux-linux.de> 1:8.5-1
- Version update, driver version 8.493
* Thu Apr 17 2008 Karsten Brockmann <arcam@ccux-linux.de> 1:8.4-1
- Version update, driver version 8.476
* Sat Mar 15 2008 Karsten Brockmann <arcam@ccux-linux.de> 1:8.3-1
- Version update, driver version 8.471
* Sun Feb 17 2008 Karsten Brockmann <arcam@ccux-linux.de> 1:8.02-1
- Version update, driver version 8.455.2
* Sat Jan 19 2008 Karsten Brockmann <arcam@ccux-linux.de> 1:8.01-1
- Version update, driver version 8.452.1
* Fri Dec 21 2007 Karsten Brockmann <arcam@ccux-linux.de> 1:7.12-1
- Version update, driver version 8.443.1
* Sun Nov 25 2007 Karsten Brockmann <arcam@ccux-linux.de> 1:7.11-1
- Version update, driver version 8.433, new ATI versioning scheme
* Sat Nov 17 2007 Karsten Brockmann <arcam@ccux-linux.de> 8.42.3-2
- rebuilt against mesa 7.0.2
* Wed Oct 23 2007 Karsten Brockmann <arcam@ccux-linux.de> 8.42.3-1
- Version update
* Thu Oct 11 2007 Karsten Brockmann <arcam@ccux-linux.de> 8.41.7-1
- Version update
* Sat Sep 09 2007 Karsten Brockmann <arcam@ccux-linux.de> 8.40.4-1
- Version update
* Sat Sep 09 2007 Karsten Brockmann <arcam@ccux-linux.de> 8.38.6-2
- rebuilt against X.org 7.3
* Tue Jul 03 2007 Karsten Brockmann <arcam@ccux-linux.de> 8.38.6-1
- Version update
* Fri Jun 08 2007 Karsten Brockmann <arcam@ccux-linux.de> 8.37.6-1
- Version update
* Fri Apr 20 2007 Karsten Brockmann <arcam@ccux-linux.de> 8.36.5-1
- Version update
* Thu Mar 15 2007 Karsten Brockmann <arcam@ccux-linux.de> 8.34.8-1
- Version update
* Thu Jan 11 2007 Karsten Brockmann <arcam@ccux-linux.de> 8.33.6-1
- Version update
* Thu Dec 14 2006 Karsten Brockmann <arcam@ccux-linux.de> 8.32.5-1
- Version update
* Wed Nov 01 2006 Karsten Brockmann <arcam@ccux-linux.de> 8.30.3-1
- Version update
* Mon Sep 25 2006 Karsten Brockmann <arcam@ccux-linux.de> 8.29.6-1
- Version update
* Thu Sep 14 2006 Christian Metzen <metzench@ccux-linux.de> 8.28.8-1
- Version update, xorg 7.1
* Sat Jul 08 2006 Karsten Brockmann <arcam@ccux-linux.de> 8.26.18-1
- Version update
* Sat Jun 10 2006 Christian Metzen <metzench@ccux-linux.de> 8.25.18-1
- Version update
* Sat Apr 29 2006 Christian Metzen <metzench@ccux-linux.de> 8.24.8-3
- modified .desktop file
* Sat Apr 29 2006 Christian Metzen <metzench@ccux-linux.de> 8.24.8-2
- Bugfix, added desktop link
* Fri Apr 21 2006 Christian Metzen <metzench@ccux-linux.de> 8.24.8-1
- Initial Release with new kmod helper
